import { BlockLocation,Commands, World } from 'mojang-minecraft';

const onTickEvent = World.events.tick;
    
var tickperSecond = 0;
var minutes = 0;
var seconds = 10;
var pause = 0;	

const arena1 = ["x=-13,y=-60,z=-60","x=3,y=-60,z=-60"];

const resourceGen1 = ["x=16,y=-60,z=-60","x=-26,y=-60,z=-60"];
//shops
const upgrade_shop = ["-24 -60 -67","14 -60 -53"];
const armor_shop = ["-25 -60 -67","15 -60 -53"];
const snowball_shop = ["-24 -60 -53","14 -60 -67"];
const item_shop = ["-25 -60 -53","15 -60 -67"];

var blueGenLvl = 1;
var redGenLvl = 1;

var players;
	
export class Arena{
	
	static stopRound(){
	Commands.run(`execute @a ~ ~ ~ stopsound @a`, World.getDimension(`overworld`));	
	destroyWall();
	cleanArena();	
	clearTags();
	returnLobby();
	onTickEvent.unsubscribe(prepareTimer);	
	onTickEvent.unsubscribe(gameStart);	
	}
	
	static pause(){
	pause = 1;	
	}
	
	static cont(){
	pause = 0;	
	}
	
	static prepareTime(){
	minutes = 0;
	seconds = 59;
	blueGenLvl = 1;
	redGenLvl = 1;
	players = World.getPlayers();
	cleanArena();
	arenaSetup();
	teleportArena();
	onTickEvent.subscribe(prepareTimer);
	}
	
}

function prepareTimer(eventData){
	statueHealth();
	if(pause == 0){
	if(tickperSecond >= 20){
	resourceGen();
	upgradeGens();
	upgradeArmor();
	Commands.run(`title @a actionbar §6--Stage: Prepare--\n§a          ${minutes}:${seconds}`, World.getDimension(`overworld`));	
		if(seconds == 0){
		destroyWall();
		onTickEvent.unsubscribe(prepareTimer);
		seconds = 59;
		minutes = 4;
		Commands.run(`execute @a ~ ~ ~ playsound note.guitar @s ~ ~ ~ 1 2`, World.getDimension(`overworld`));
		Commands.run(`execute @a ~ ~ ~ playsound bgm.one @s`, World.getDimension(`overworld`));	
		onTickEvent.subscribe(gameStart);
		}else if(seconds <= 3){
		Commands.run(`execute @a ~ ~ ~ playsound note.guitar @s`, World.getDimension(`overworld`));		
		}
	seconds--;
	tickperSecond = 0;
	}else{
	tickperSecond++;
	}
	}else{
	Commands.run(`title @a actionbar §6--Game Pause--\n§a       ${minutes}:${seconds}`, World.getDimension(`overworld`));	
	}		
}

function gameStart(eventData){
	if(pause == 0){
	resetBounds();
	statueHealth();
	if(tickperSecond >= 20){
	resourceGen();
	detectWin();
	upgradeGens();
	Commands.run(`title @a actionbar §6--Remaining Time--\n§a        ${minutes}:${seconds}`, World.getDimension(`overworld`));	
		if(seconds == 0){
			if(seconds <= 3 && minutes == 0){
			Commands.run(`execute @a ~ ~ ~ playsound bgm.victory @s`, World.getDimension(`overworld`));	
			Commands.run(`title @a title Ran Out Of Time`, World.getDimension(`overworld`));
			Commands.run(`execute @a ~ ~ ~ stopsound @a`, World.getDimension(`overworld`));	
			cleanArena();
			clearTags();
			returnLobby();
			onTickEvent.unsubscribe(gameStart);
			}
		minutes--;
		seconds = 59;	
		}else if(seconds <= 3 && minutes == 0){
		Commands.run(`execute @a ~ ~ ~ playsound note.guitar @s`, World.getDimension(`overworld`));		
		}
		seconds--;
		tickperSecond = 0;	
	}else{
	tickperSecond++;	
	}
	}else{
	Commands.run(`title @a actionbar §6--Game Pause--\n§a       ${minutes}:${seconds}`, World.getDimension(`overworld`));	
	}
}

function detectWin(){
	try{
	Commands.run(`testfor @e[family=statue,${arena1[0]},r=2]`,World.getDimension(`overworld`));
	}catch(e){
	Commands.run(`title @a title Red Team Won`,World.getDimension(`overworld`));
	Commands.run(`execute @a ~ ~ ~ stopsound @a`, World.getDimension(`overworld`));	
	Commands.run(`execute @a ~ ~ ~ playsound bgm.victory @s`, World.getDimension(`overworld`));	
	cleanArena();
	clearTags();
	returnLobby();
	onTickEvent.unsubscribe(gameStart);
	}
	try{
	Commands.run(`testfor @e[family=statue,${arena1[1]},r=2]`,World.getDimension(`overworld`));
	}catch(e){
	Commands.run(`title @a title Blue Team Won`,World.getDimension(`overworld`));
	Commands.run(`execute @a ~ ~ ~ stopsound @a`, World.getDimension(`overworld`));
	Commands.run(`execute @a ~ ~ ~ playsound bgm.victory @s`, World.getDimension(`overworld`));	
	cleanArena();
	clearTags();
	returnLobby();
	onTickEvent.unsubscribe(gameStart);	
	}
}

function upgradeGens(){
for(let player in players){
	try{
	let clearTargetIron = Commands.run(`clear @a iron_block`,World.getDimension(`overworld`)).statusMessage;
	let targetPlayer = players.find(p => clearTargetIron.includes(p.nameTag));
	let tags = Commands.run(`tag ${targetPlayer.nameTag} list`,World.getDimension(`overworld`)).statusMessage;
		if(tags.includes("red")){
		Commands.run(`tellraw @a[tag=red] {"rawtext":[{"text":"§cResource Generator Upgraded to §rIron"}]}`,World.getDimension(`overworld`));
		redGenLvl = 2;
		}else if(tags.includes("blue")){
		Commands.run(`tellraw @a[tag=blue] {"rawtext":[{"text":"§1Resource Generator Upgraded to §rIron"}]}`,World.getDimension(`overworld`));		
		blueGenLvl = 2;		
		}
	}catch(e){}
	try{
	let clearTargetIron = Commands.run(`clear @a gold_block`,World.getDimension(`overworld`)).statusMessage;
	let targetPlayer = players.find(p => clearTargetIron.includes(p.nameTag));
	let tags = Commands.run(`tag ${targetPlayer.nameTag} list`,World.getDimension(`overworld`)).statusMessage;
		if(tags.includes("red")){
		Commands.run(`tellraw @a[tag=red] {"rawtext":[{"text":"§cResource Generator Upgraded to §eGold"}]}`,World.getDimension(`overworld`));
		redGenLvl = 3;
		}else if(tags.includes("blue")){
		Commands.run(`tellraw @a[tag=blue] {"rawtext":[{"text":"§1Resource Generator Upgraded to §eGold"}]}`,World.getDimension(`overworld`));	
		blueGenLvl = 3;		
		}
	}catch(e){}
	try{
	let clearTargetIron = Commands.run(`clear @a diamond_block`,World.getDimension(`overworld`)).statusMessage;
	let targetPlayer = players.find(p => clearTargetIron.includes(p.nameTag));
	let tags = Commands.run(`tag ${targetPlayer.nameTag} list`,World.getDimension(`overworld`)).statusMessage;
		if(tags.includes("red")){
		Commands.run(`tellraw @a[tag=red] {"rawtext":[{"text":"§cResource Generator Upgraded to §bDiamond"}]}`,World.getDimension(`overworld`));
		redGenLvl = 4;
		}else if(tags.includes("blue")){
		Commands.run(`tellraw @a[tag=blue] {"rawtext":[{"text":"§1Resource Generator Upgraded to §bDiamond"}]}`,World.getDimension(`overworld`));		
		blueGenLvl = 4;		
		}
	}catch(e){}
}
}

//---------------------------------You Can Edit This-----------------------------------------------------//
function arenaSetup(){
let statues = ["sb:snow_golem","sb:gift"];
let coords;
setupShops();
try{
Commands.run(`structure load arena1_wall -5 -60 -70`,World.getDimension(`overworld`));
Commands.run(`setblock -19 -60 -64 chest 0 destroy`,World.getDimension(`overworld`));
Commands.run(`setblock 9 -60 -56 chest 0 destroy`,World.getDimension(`overworld`));
try{
Commands.run(`kill @e[type=item]`,World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`clear @a`,World.getDimension(`overworld`));
}catch(e){}
try{
}catch(e){}
for(let teams=1; teams<=2; teams++){
let random = Math.floor(Math.random()*2);
	switch(teams){
		case 1:
		coords = arena1[0].replace(/([xyz=])/g,'');
		coords = coords.replace(/,/g,' ');
		Commands.run(`summon ${statues[random]} ${coords} team_blue`,World.getDimension(`overworld`));
		break;
		
		case 2:
		coords = arena1[1].replace(/([xyz=])/g,'');
		coords = coords.replace(/,/g,' ');
		Commands.run(`summon ${statues[random]} ${coords} team_red`,World.getDimension(`overworld`));
		break;
	}
}
}catch(e){}
}

function cleanArena(){
try{
Commands.run(`fill 8 -60 -72 -17 -50 -48 air 0 replace sb:normal_snow`, World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`clear @a`, World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`kill @e[type=item]`, World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`event entity @e[family=sg] despawn`, World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`event entity @e[family=statue] despawn`, World.getDimension(`overworld`));	
Commands.run(`event entity @e[family=shop] despawn`, World.getDimension(`overworld`));
}catch(e){}
}

function resetBounds(){
Commands.run(`gamerule sendcommandfeedback false`, World.getDimension(`overworld`));	
try{
Commands.run(`execute @a ~ ~ ~ execute @s[x=-5,y=~,z=~,r=1,tag=blue] ~ ~ ~ tp @s ~-1 ~ ~`, World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`execute @a ~ ~ ~ execute @s[x=-5,y=~,z=~,r=1,tag=red] ~ ~ ~ tp @s ~1 ~ ~`, World.getDimension(`overworld`));
}catch(e){}	
Commands.run(`gamerule sendcommandfeedback true`, World.getDimension(`overworld`));
}

function destroyWall(){
try{
Commands.run(`gamerule dotiledrops false`, World.getDimension(`overworld`));			
Commands.run(`fill -5 -60 -70 -5 -57 -50 air 0 destroy`, World.getDimension(`overworld`));		
}catch(e){}	
}

function resourceGen(){
let bluegen = resourceGen1[0].replace(/([xyz=])/g,'');
bluegen = bluegen.replace(/,/g,' ');
let redgen = resourceGen1[1].replace(/([xyz=])/g,'');
redgen = redgen.replace(/,/g,' ');
	
try{
Commands.run(`gamerule dotiledrops true`, World.getDimension(`overworld`));	
}catch(e){}

try{
switch(blueGenLvl){	
	case 1:
		if((seconds%6) == 0){
		Commands.run(`setblock ${bluegen} sb:resource_gen1`,World.getDimension(`overworld`));	
		}
	break;
	
	case 2:
		if((seconds%5) == 0){
		Commands.run(`setblock ${bluegen} sb:resource_gen1`,World.getDimension(`overworld`));	
		}
	break;
	
	case 3:
		if((seconds%4) == 0){
		Commands.run(`setblock ${bluegen} sb:resource_gen2`,World.getDimension(`overworld`));	
		}
	break;
	case 4:
		if((seconds%3) == 0){
		Commands.run(`setblock ${bluegen} sb:resource_gen2`,World.getDimension(`overworld`));	
		}
	break;

}
}catch(e){}
try{
switch(redGenLvl){	
	case 1:
		if((seconds%6) == 0){
		Commands.run(`setblock ${redgen} sb:resource_gen1`,World.getDimension(`overworld`));	
		}
	break;
	
	case 2:
		if((seconds%5) == 0){
		Commands.run(`setblock ${redgen} sb:resource_gen1`,World.getDimension(`overworld`));	
		}
	break;
	
	case 3:
		if((seconds%4) == 0){
		Commands.run(`setblock ${redgen} sb:resource_gen2`,World.getDimension(`overworld`));	
		}
	break;
	case 4:
		if((seconds%3) == 0){
		Commands.run(`setblock ${redgen} sb:resource_gen2`,World.getDimension(`overworld`));	
		}
	break;

}
}catch(e){}
try{
Commands.run(`gamerule dotiledrops false`, World.getDimension(`overworld`));	
}catch(e){}
}

function setupShops(){
//gen upgrade
Commands.run(`summon sb:upgrade_shop ${upgrade_shop[0]}`, World.getDimension(`overworld`));
Commands.run(`summon sb:upgrade_shop ${upgrade_shop[1]}`, World.getDimension(`overworld`));
//armor upgrade
Commands.run(`summon sb:armor_upgrade_shop ${armor_shop[0]}`, World.getDimension(`overworld`));
Commands.run(`summon sb:armor_upgrade_shop ${armor_shop[1]}`, World.getDimension(`overworld`));
//snowball
Commands.run(`summon sb:snowball_shop ${snowball_shop[0]}`, World.getDimension(`overworld`));
Commands.run(`summon sb:snowball_shop ${snowball_shop[1]}`, World.getDimension(`overworld`));
//item
Commands.run(`summon sb:item_shop ${item_shop[0]}`, World.getDimension(`overworld`));
Commands.run(`summon sb:item_shop ${item_shop[1]}`, World.getDimension(`overworld`));

//reset look
try{
Commands.run(`execute @e[type=!player,${resourceGen1[0]},r=9] ~ ~ ~ tp @s ~ ~ ~ facing ${resourceGen1[0].replace(/([xyz=])/g,'').replace(/,/g,' ')}`, World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`execute @e[type=!player,${resourceGen1[1]},r=9] ~ ~ ~ tp @s ~ ~ ~ facing ${resourceGen1[1].replace(/([xyz=])/g,'').replace(/,/g,' ')}`, World.getDimension(`overworld`));	
}catch(e){}
}

function statueHealth(){
try{
for(let count=0; count<=1; count++){
let coords = arena1[count].replace(/([xyz=])/g,'');
let statueCoords = coords.split(',');	
let statue = World.getDimension('overworld').getEntitiesAtBlockLocation(new BlockLocation(parseInt(statueCoords[0]),parseInt(statueCoords[1]),parseInt(statueCoords[2])));
if(!statue[0] || statue[0].id == "minecraft:player") continue;
let health = statue[0].getComponent('minecraft:health').current;
statue[0].nameTag = `${health}`;
}
}catch(e){}
}

function upgradeArmor(){
for(let player in players){
try{
	let clearTarget = Commands.run(`clear @a leather_helmet`,World.getDimension(`overworld`)).statusMessage;
	let targetPlayer = players.find(p => clearTarget.includes(p.nameTag));
	let tags = Commands.run(`tag ${targetPlayer.nameTag} list`,World.getDimension(`overworld`)).statusMessage;
		if(tags.includes("red")){
		Commands.run(`tag @a[tag=red] add leather`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=red] slot.armor.chest 0 leather_chestplate`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=red] slot.armor.legs 0 leather_leggings`,World.getDimension(`overworld`));
		Commands.run(`tellraw @a[tag=red] {"rawtext":[{"text":"§1Upgraded to §rLeather Armor"}]}`,World.getDimension(`overworld`));	
		}else if(tags.includes("blue")){
		Commands.run(`tag @a[tag=blue] add leather`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=blue] slot.armor.chest 0 leather_chestplate`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=blue] slot.armor.legs 0 leather_leggings`,World.getDimension(`overworld`));
		Commands.run(`tellraw @a[tag=blue] {"rawtext":[{"text":"§1Upgraded to §rLeather Armor"}]}`,World.getDimension(`overworld`));			
		}
	}catch(e){}
try{
	let clearTarget = Commands.run(`clear @a iron_helmet`,World.getDimension(`overworld`)).statusMessage;
	let targetPlayer = players.find(p => clearTarget.includes(p.nameTag));
	let tags = Commands.run(`tag ${targetPlayer.nameTag} list`,World.getDimension(`overworld`)).statusMessage;
		if(tags.includes("red")){
		Commands.run(`tag @a[tag=red] remove leather`,World.getDimension(`overworld`));
		Commands.run(`tag @a[tag=red] add iron`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=red] slot.armor.chest 0 iron_chestplate`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=red] slot.armor.legs 0 iron_leggings`,World.getDimension(`overworld`));
		Commands.run(`tellraw @a[tag=red] {"rawtext":[{"text":"§1Upgraded to §rIron Armor"}]}`,World.getDimension(`overworld`));	
		}else if(tags.includes("blue")){
		Commands.run(`tag @a[tag=blue] remove leather`,World.getDimension(`overworld`));
		Commands.run(`tag @a[tag=blue] add iron`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=blue] slot.armor.chest 0 iron_chestplate`,World.getDimension(`overworld`));
		Commands.run(`replaceitem entity @a[tag=blue] slot.armor.legs 0 iron_leggings`,World.getDimension(`overworld`));
		Commands.run(`tellraw @a[tag=blue] {"rawtext":[{"text":"§1Upgraded to §rIron Armor"}]}`,World.getDimension(`overworld`));			
		}
	}catch(e){}
}	
}

function clearTags(){
/*
try{
Commands.run(`tag @a remove red`,World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`tag @a remove blue`,World.getDimension(`overworld`));
}catch(e){}
*/
try{
Commands.run(`tag @a remove leather`,World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`tag @a remove iron`,World.getDimension(`overworld`));
}catch(e){}
}

function teleportArena(){
let coords = resourceGen1[0].replace(/([xyz=])/g,'');
let arenaCoords = coords.split(',');
let x = parseInt(arenaCoords[0]);
let y = parseInt(arenaCoords[1]);
let z = parseInt(arenaCoords[2]);
try{
Commands.run(`tp @a[tag=red] ${x} ${y} ${z}`,World.getDimension(`overworld`));	
}catch(e){}
coords = resourceGen1[1].replace(/([xyz=])/g,'');
arenaCoords = coords.split(',');
x = parseInt(arenaCoords[0]);
y = parseInt(arenaCoords[1]);
z = parseInt(arenaCoords[2]);
try{
Commands.run(`tp @a[tag=blue] ${x} ${y} ${z}`,World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`tp @a[tag=!blue,tag=!red] -4 -54 -60`,World.getDimension(`overworld`));
}catch(e){}
try{
Commands.run(`execute @a ~ ~ ~ spawnpoint`,World.getDimension(`overworld`));
}catch(e){}
}

function returnLobby(){
Commands.run(`tp @a 87 -59 -78`,World.getDimension(`overworld`));	
try{
Commands.run(`execute @a ~ ~ ~ spawnpoint`,World.getDimension(`overworld`));
}catch(e){}
}